package me.mrletsplay.bmareas.command.marker;

import java.util.AbstractMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import de.bluecolored.bluemap.api.markers.POIMarker;
import me.mrletsplay.bmareas.BMAreas;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class MarkerListCommand extends FabricCommand {

	public MarkerListCommand() {
		super("list");
		setDescription("List all of your markers");
		setUsage("/marker list");
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 0) {
			sendCommandInfo(event.getSender());
			return;
		}

		String prefix = p.getUuid().toString() + "_";
//		List<Marker> markers = DynmapAreasMod.markerMarkerSet.getMarkers().stream()
//				.filter(a -> a.getMarkerID().startsWith(prefix))
//				.collect(Collectors.toList());
		List<Map.Entry<String, POIMarker>> markers = BMAreas.getMarkerMarkerSet(p.getWorld()).getMarkers().entrySet().stream()
			.filter(en -> en.getKey().startsWith(prefix) && en.getValue() instanceof POIMarker)
			.map(en -> new AbstractMap.SimpleEntry<>(en.getKey(), (POIMarker) en.getValue()))
			.collect(Collectors.toList());

		if(markers.isEmpty()) {
			p.sendMessage(Text.literal("§cYou haven't added any markers yet"));
			return;
		}

		p.sendMessage(Text.literal("§aYour markers:"));
		for(Map.Entry<String, POIMarker> area : markers) {
			p.sendMessage(Text.literal(String.format("§6%s: §7%s", area.getKey().substring(prefix.length()), area.getValue().getLabel())));
		}
	}

}
